#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cctype>

#include <iostream>
#include <sstream>
#include <string>

#include <vector>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <stack>
#include <algorithm>
using namespace std;

#define FOR(i,n) for (int i=0; i<(n); i++)
#define FORTO(i,a,b) for (int i=(a); i<=(b); i++)
#define DEBUG(x) cout << '>' << #x << ':' << x << endl;
#define SIZE(x) int(x.size())

typedef pair<int,int> PII;
typedef long long ll;

double D[234][234];

char buff1[547];
char buff2[547];

int main()
{
	while (true) {
		int N, M;
		scanf("%d", &N);
		if (!N) return 0;
		map<string,int> Num;
		FOR(i,N) FOR(j,N) D[i][j] = 0.0;
		FOR(i,N) {
			scanf("%s", buff1);
			Num[string(buff1)] = i;
			D[i][i] = 1.0;
		}
		
		scanf("%d", &M);
		FOR(i,M) {
			int A, B;
			scanf("%s %s %d:%d", buff1, buff2, &A, &B);
			D[Num[string(buff1)]][Num[string(buff2)]] = double(B)/A;
		}
		
		FOR(k,N) FOR(i,N) FOR(j,N)
			D[i][j] = max(D[i][j],D[i][k]*D[k][j]);
		bool ok = false;
		FOR(i,N) if (D[i][i] > 1.0+1e-6)
			ok = true;
		if (ok) printf("Arbitrage\n"); else printf("Ok\n");
	}
	return 0;
}

