#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cctype>

#include <iostream>
#include <sstream>
#include <string>

#include <vector>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <stack>
#include <algorithm>
using namespace std;

#define FOR(i,a,b) for ( int i = (a); i < (b); i++)
#define FOR2(i,a,b) for (int i = (a); i > (b); i--)
/*
#define FOR(i,n) for (int i=0; i<(n); i++)
#define FORTO(i,a,b) for (int i=(a); i<=(b); i++)
#define FORD(i,n) for (int i = (n)-1; i>=0; i--)
*/

#define DEBUG(x) cout << '>' << #x << ':' << x << endl;
#define SIZE(x) int(x.size())

typedef pair<int,int> PII;
typedef long long ll;

////////////////////////////////////////////////////////////////////////////////////////////////

char input[10];
int len;

void solve1()
{
	int n = input[0]-'0';
	vector<int> v;
	//idem dole
	if (n <= 4)
	{
		FOR2(i, n, 0) v.push_back(i);
		FOR(i, 0, 10) v.push_back(i);
	}
	//ideme hore
	else
	{
		FOR(i, n, 9) v.push_back(i);
		FOR2(i, 9, -1) v.push_back(i);
	}
	
	printf("%d\n", v.size()-1);
	FOR(i, 1, v.size()) printf("%d ", v[i]);
	printf("\n");
}

char cycle[10000047][8];

void solve()
{	
	memset(cycle, 'x', sizeof(cycle));
	int sz = 9;
	FOR(i, 1, len) sz *= 10;
	int sz2 = sz/9;
	
	//vypise pravy okraj
	int index = 0;
	while (index < sz)
	{
		FOR(i, 1, 10) cycle[index++][len-1] = i+'0';
		FOR2(i, 9, 0) cycle[index++][len-1] = i+'0';
	}
	while (index < sz+sz2) cycle[index++][len-1] = '0';
	
	//vypise lavy
	index = 0;
	FOR(i, 0, 10) FOR(j, 0, sz/10) cycle[index++][0] = i+'0';
	FOR2(i,9,-1) FOR(j, 0, sz2/10) cycle[index++][0] = i+'0';
	
	//vypise zvysne
	int num = 9;
	FOR2(dig, len-2, 0)
	{
		index = 0;
		while (index < sz)
		{
			FOR(i, 0, 10) FOR(j, 0, num) cycle[index++][dig] = i+'0';
			FOR2(i,9,-1) FOR(j, 0, num) cycle[index++][dig] = i+'0';
		}
		num /= 9;
		while (index < sz+sz2)
		{
			FOR(i, 0, 10) FOR(j, 0, num) cycle[index++][dig] = i+'0';
			FOR2(i,9,-1) FOR(j, 0, num) cycle[index++][dig] = i+'0';
		}
		num *= 90;
	}
	
	FOR(i, 0, index)
	{
		cycle[i][len] = '\0';
		//printf("%s\n", cycle[i]);
	}
	
	printf("%d\n", sz+sz2-1);
	
	int inp;
	FOR(i, 0, index)
	{
		bool ok = true;
		FOR(j, 0, len)
			if (cycle[i][j] != input[j]) ok = false;
		if (ok) { inp = i; break; }
	}
	
	FOR(i, 0, sz+sz2-1)
	{
		printf("%s ", cycle[(inp+1+i)%index]);
	}
}

int main()
{
	while (1)
	{
		scanf("%s", input);
		if (input[0] == '-') break;
		len = strlen(input);
		
		if (len == 1) solve1();
		else solve();
	}
	
	return 0;
}

