#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cctype>

#include <iostream>
#include <sstream>
#include <string>

#include <vector>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <stack>
#include <algorithm>
using namespace std;


#define FOR(i,n) for (int i=0; i<(n); i++)
#define FORTO(i,a,b) for (int i=(a); i<=(b); i++)
#define FORD(i,n) for (int i = (n)-1; i>=0; i--)


#define DEBUG(x) cout << '>' << #x << ':' << x << endl;
#define SIZE(x) int(x.size())

typedef pair<int,int> PII;
typedef long long ll;

bool X[20007];
bool Y[20007];
bool D1[40007];
bool D2[40007];

int dimX, dimY, N;

int diag1(int x, int y) {
	return x+y;
}

int diag2(int x, int y) {
	return x-y+dimY;
}

int main()
{
	while (true) {
		scanf("%d %d %d" ,&dimX, &dimY, &N);
		if (!dimX && !dimY && !N) return 0;
		FORTO(i,0,dimX+7) X[i] = false;
		FORTO(i,0,dimY+7) Y[i] = false;
		FORTO(i,0,dimX+dimY+7) D2[i] = false;
		FORTO(i,0,dimX+dimY+7) D1[i] = false;
		
		FOR(i,N) {
			int x, y;
			scanf("%d %d", &x, &y);
			X[x] = true;
			Y[y] = true;
			D1[diag1(x,y)] = true;
			D2[diag2(x,y)] = true;
		}
		int Sum = 0;
		FORTO(y,1,dimY) if (!Y[y]) {
			FORTO(x,1,dimX) if (!X[x]) {
				if (D1[diag1(x,y)]) continue;
				if (D2[diag2(x,y)]) continue;
				Sum++;
			}
		}
		printf("%d\n", Sum);
	}
	return 0;
}

